# REST API IMPLEMENTATION IN TYPO3 FLOW

> REST stands for REpresentational State Transfer.REST is web standards based architecture and uses HTTP Protocol for data communication (*http://www.tutorialspoint.com/restful/restful_introduction.htm*).

## Implementation in TYPO3 Flow

* Add below code in main Routes.yaml file in main Configuration.

```
##
# Subroutes from the Joson.Rest package.
#

-
  name: 'Joson Rest'
  uriPattern: '<JosonRestSubroutes>'
  subRoutes:
    JosonRestSubroutes:
      package: Joson.Rest

```

* Create a folder 'Joson.Rest' inside 'Packages' folder.

* make this folder as git local repository.And pull this git entire git repository. Type the below command in terminal.

```
git pull  http://192.168.1.113/pits/rest_implementation.git

```
## Important point

Configure route in the implemented package is important.For achieving this goal,we should edit Routes.yaml file in the implemented package(Joson.Rest).
> *httpMethods* in the route configuration part, determines which http method can perform the mentioned route. An example configuration is given below.Possible *httpMethods* values are GET,PUT,POST,DELETE,PATCH,OPTIONS etc.
```
-
  name: 'Add user details'
  uriPattern: 'api/users'
  defaults:
    @package: 'Joson.Rest'
    @controller: 'Standard'
    @action: 'index'
  httpMethods: ['PUT']
  appendExceedingArguments: true
```

## References

#### HTTP Status codes
```
https://httpstatuses.com/
https://en.wikipedia.org/wiki/List_of_HTTP_status_codes
```
#### HTTP Methods
```
http://www.tutorialspoint.com/restful/restful_methods.htm
http://www.restapitutorial.com/lessons/httpmethods.html
```
#### TYPO3 Flow route
```
http://flowframework.readthedocs.io/en/stable/TheDefinitiveGuide/PartIII/Routing.html
```





